<template>
  <form>
    <div class="row">
      <div class="col-2">
        <label>購買オーダ</label>
        <v-text-field
          v-model="po"
          :error-messages="poErrors"
          :counter="10"
          maxlength="10"
          outlined
          required
          v-on="searchGridByPo"
          @input="$v.po.$touch()"
          @blur="$v.po.$touch()"
        ></v-text-field>
      </div>
      <div class="col-1"></div>
      <div class="col-2">
        <label> 購入先</label>
        <v-text-field
          v-model="customer"
          :error-messages="customerErrors"
          :counter="20"
          outlined
          maxlength="20"
          required
          @input="$v.customer.touch()"
          @blur="$v.customer.$touch()"
        ></v-text-field>
      </div>
    </div>
    <div class="row">
      <div class="col-2">
        <label>E-maii</label>
        <v-text-field
          v-model="email"
          :error-messages="emailErrors"
          outlined
          required
          @input="$v.email.$touch()"
          @blur="$v.email.$touch()"
        ></v-text-field>
      </div>
      <div class="col-1"></div>
      <div class="col-2">
        <label>Item</label>
        <v-select
          v-model="select"
          :items="items"
          :error-messages="selectErrors"
          outlined
          required
          @change="$v.select.$touch()"
          @blur="$v.select.$touch()"
        ></v-select>
      </div>
    </div>

    <v-checkbox
      v-model="checkbox"
      :error-messages="checkboxErrors"
      label="Do you agree?"
      required
      @change="$v.checkbox.$touch()"
      @blur="$v.checkbox.$touch()"
    ></v-checkbox>
  </form>
</template>

<script>
import { validationMixin } from "vuelidate";
import { required, maxLength } from "vuelidate/lib/validators";

export default {
  //TODO: mixins意味が分かってない
  mixins: [validationMixin],

  validations: {
    po: { required, maxLength: maxLength(10) },
    customer: { required },
  },

  data: () => ({
    po: "",
    customer: "",
  }),

  // 算出プロパティ 
  computed: {
    poErrors() {
      const errors = [];
      if (!this.$v.po.$dirty) return errors;
      !this.$v.po.maxLength &&
        errors.push("購買オーダは10文字以下で入力してください");
      !this.$v.po.required && errors.push("購買オーダは必須項目です");
      return errors;
    },
    customerErrors() {
      const errors = [];
      if (!this.$v.customer.$dirty) return errors;
      !this.$v.customer.required && errors.push("購入先は必須項目です");
      return errors;
    },
  },

  methods: {
    submit() {
      this.$v.$touch();
    },
  },
};
</script>
